import db.DbSupport
import groovy.sql.Sql
import oracle.jdbc.driver.OracleTypes

/*
Run query to test cache hit ratio
parameters:
id - initial ID, will be increased by 1 in a loop
n - sequence limit - in a loop are executed sequences from length 1 to n 
k - repeat count - each statement sequency is repeated k-times
*/ 

def dbSupport = new DbSupport()
def con = dbSupport.getDbConnection('jarasres_lab')
assert con != null

/* get Grovvy Sql Connection */
 def groovyCon = new groovy.sql.Sql(con)
 
// reset cache
groovyCon.execute '''BEGIN
     DBMS_RESULT_CACHE.FLUSH; 
END;''' 
 
 def id = 1024
 def n = 50
 def k = 5
 

def ct = System.currentTimeMillis()
def queryCnt = 0

   
n.times {nn -> 
 println "starting sequence $nn"
k. times { kk ->
 //println "starting sequence $nn for ${(id .. (id+nn))}"
 (id .. (id+nn)).each {iid -> 
 //println "query $iid"
 groovyCon.eachRow ("""select /*+ RESULT_CACHE */  a.* /*, lpad('x',2048,'y') as pad*/
 from priv_table a
 start with id = ${iid}
 connect by prior id =  boss_id""") {}
 queryCnt += 1
}  
}
}  

def ela =  System.currentTimeMillis()  - ct
println "Executed ${queryCnt} in ${ela} ms. Avg ela =  ${ela / queryCnt}"  

/*  id = 1 exception
Caught: java.sql.SQLException: ORA-01436: CONNECT-BY-Schleife in Benutzerdaten

java.sql.SQLException: ORA-01436: CONNECT-BY-Schleife in Benutzerdaten

        at oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:439)
        at oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:395)
        at oracle.jdbc.driver.T4C8Oall.processError(T4C8Oall.java:802)
        at oracle.jdbc.driver.T4CTTIfun.receive(T4CTTIfun.java:436)
        
run statistics

1st run with pad
Executed 6375 in 37604 ms. Avg ela =  5.8986666667

Cache Size (Blocks) 3072 Result Size Maximum (Blocks)  153
   % Hit ratio   % Alloc  Crea cnt  Find cnt   Invd cnt   Del cnt
       99        39         1       151         0         0
       99        40         1       161         0         0
       99        41         1       153         0         0
      100        41         0       176         0         0
       99        42         1       193         0         0
       99        43         1       179         0         0
       99        44         1       179         0         0
       99        45         1       161         0         0
      100        45         0       154         0         0
       99        46         1       179         0         0 
       
compare with the new query with MV
Executed 6375 in 25500 ms. Avg ela =  4
              
*/

